package frc.robot.constants;

import static edu.wpi.first.units.Units.Volts;
import static edu.wpi.first.units.Units.Second;
import static edu.wpi.first.units.Units.Seconds;

import com.revrobotics.spark.config.SparkMaxConfig;
import com.revrobotics.spark.config.SparkBaseConfig.IdleMode;

import edu.wpi.first.wpilibj2.command.sysid.SysIdRoutine;
import edu.wpi.first.wpilibj2.command.sysid.SysIdRoutine.Config;

public class ElevatorConstants {
    public static final int kElevatorMotor1ID = 0;
    public static final int kElevatorMotor2ID = 0;

    public static final int kTopLimitSwitchID = 0;
    public static final int kBottomLimitSwitchID = 0;

    public static final double kEncoderConversionFactor = 0;

    public static final int kMotorAmpsMax = 0;

    public static final double kPositionControllerP = 0;
    public static final double kPositionControllerI = 0;
    public static final double kPositionControllerD = 0;
    
    public static final double kVelocityControllerP = 0;
    public static final double kVelocityControllerI = 0;
    public static final double kVelocityControllerD = 0;

    public static final double kFeedForwardS = 0;
    public static final double kFeedForwardG = 0;
    public static final double kFeedForwardV = 0;

    public static final double kElevatorMaxVelocity = 0;

    public static final double kElevatorCoralIntakePosition = 0;
    public static final double kElevatorL1Position = 0;
    public static final double kElevatorL2Position = 0;
    public static final double kElevatorL3Position = 0;
    public static final double kElevatorL4Position = 0;
    public static final double kElevatorL2AlgaePosition = 0;
    public static final double kElevatorL3AlgaePosition = 0;
    public static final double kElevatorBracePosition = 0;
    public static final double kElevatorMaxHeight = 0;

    // 1, 7, 10 are the defaults for these, change as necessary
    public static final double kSysIDRampRate = 1;
    public static final double kSysIDStepVolts = 7;
    public static final double kSysIDTimeout = 10;

    public static final IdleMode kIdleMode = IdleMode.kBrake;

    // YOU SHOULDN'T NEED TO CHANGE ANYTHING BELOW THIS LINE UNLESS YOU'RE ADDING A NEW CONFIGURATION ITEM
    
    public static final SysIdRoutine.Config kSysIDConfig = new Config(
        Volts.of(kSysIDRampRate).per(Second), 
        Volts.of(kSysIDStepVolts), 
        Seconds.of(kSysIDTimeout)
    );

    public static final SparkMaxConfig motorConfig = new SparkMaxConfig();
    
    static {
        motorConfig
            .smartCurrentLimit(kMotorAmpsMax)
            .idleMode(kIdleMode);
        motorConfig.encoder
            .positionConversionFactor(kEncoderConversionFactor)
            .velocityConversionFactor(kEncoderConversionFactor / 60.0);
    }
}
