package frc.robot.subsystems;

import com.revrobotics.spark.SparkMax;
import com.revrobotics.spark.SparkLowLevel.MotorType;

import edu.wpi.first.wpilibj.DigitalInput;
import edu.wpi.first.wpilibj2.command.Command;
import edu.wpi.first.wpilibj2.command.SubsystemBase;
import frc.robot.constants.ManipulatorConstants;

public class Manipulator extends SubsystemBase {
    private SparkMax manipulatorMotor;

    private DigitalInput coralBeamBreak;
    private DigitalInput algaeBeamBreak;

    public Manipulator() {
        manipulatorMotor = new SparkMax(
            ManipulatorConstants.kManipulatorMotorID, 
            MotorType.kBrushless
        );

        coralBeamBreak = new DigitalInput(ManipulatorConstants.kCoralBeamBreakID);
        algaeBeamBreak = new DigitalInput(ManipulatorConstants.kAlgaeBeamBreakID);
    }

    public Command runManipulator(double speed) {
        return run(() -> {
            manipulatorMotor.set(speed);
        });
    }

    public Command runUntilCollected(double speed, boolean coral) {
        return run(() -> {
            manipulatorMotor.set(coral ? speed : speed * -1);
        }).until(() -> coralBeamBreak.get() || algaeBeamBreak.get());
    }
}
